
#ifndef USM3DPROJECTIOM_H
#define USM3DPROJECTIOM_H

#include "USmBaseType.h"
#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>

class CSm3DProjection: public ISmActor
{
public:
	enum
	{
		LOW_INDEX  = 0,
		HIGH_INDEX = 100,
	};
	enum TProjectionMode
	{
		pmPerspecive,
		pmOrthogonal,
	};

private:
	IDirect3DDevice9* m_pD3DDevice;
	TD3DMatrix m_projectionMatrix[HIGH_INDEX+1];
	TProjectionMode m_projectionMode;
	int m_projectionStep;

	void m_InitiaizeProjectionMatrix(void);
	void m_SetProjectionMode(TProjectionMode mode);
	void m_Apply(void);

public:
	CSm3DProjection(IDirect3DDevice9* pD3DDevice);
	unsigned long Process(long refTime = 0, ISmActor* pSender = 0);

	TProjectionMode GetMode(void) { return m_projectionMode; }
	void SetMode(TProjectionMode mode) { m_SetProjectionMode(mode); }

	__declspec( property( get = GetMode,  put = SetMode  ) ) TProjectionMode Mode;
};

#endif // #ifndef USM3DPROJECTIOM_H
